
jQuery(document).ready(function () {

    var $start = jQuery("#arp_tour_guide_start");
    var tour = new Tour({
        storage: false,
        onStart: function () {
            var template_length = jQuery('.arp_editable_templates').length;
            if (template_length > 3) {
                jQuery('#arplite_save_table_notice_editor').bPopup();
                tour.end();
                return;
            }
            return $start.addClass("disabled", true);
        },
        onEnd: function () {
            $start.removeClass("disabled", true);
        }
    });

    var temlpate_start = "<div style='margin-top:18px;' class='popover tour arp_tour'>";
    temlpate_start += "<div class='arrow'></div><h3 class='popover-title'></h3>";
    temlpate_start += "<div class='popover-content'></div><div class='popover-navigation'>";
    temlpate_start += "<button id='arp_next_one' class='arp_tour_next' style='margin:0 15px 15px;' data-role='next'>Next</button>";
    temlpate_start += "<button class='arp_tour_end_tour' style='margin-right:15px;'  data-role='end'>End tour</button>";
    temlpate_start += "</div>";
    temlpate_start += "</div>";


    tour.addSteps([
        {
            element: "#arp_template_8",
            title: "Choose your template",
            content: "Click 'Next' button to clone selected template.",
            placement: "bottom",
            backdrop: true,
            orphan: true,
            onShown: function (tour) {
                jQuery("#arp_template_8").trigger('click');
                jQuery("#arp_template_8").css('background', '#ffffff');
                jQuery("#arp_template_8").css('box-shadow', '0 0 0 4px rgba(79, 213, 214,1)');

            },
            onHide: function (tour) {
                jQuery("#arp_template_8").css('background', '');
                jQuery("#arp_template_8").css('box-shadow', '');
            },
            onNext: function (tour) {
                jQuery("#arp_template_8").find('#clone_template').trigger('click');
                setTimeout(function () {
                    EditorTourGuide(0);
                }, 1000);

                tour.end();

            },
            template: temlpate_start,
        },
    ]);

    tour.init();

    jQuery(".arp_tour_guide_start_model").click(function () {
        var ajaxurl = jQuery("#ajaxurl").val();
        var arp_tour_guide_value = jQuery(this).attr('id');
        jQuery.ajax({
            url: ajaxurl,
            type: 'POST',
            data: 'action=update_arplite_tour_guide_value&arp_tour_guide_value=' + arp_tour_guide_value,
            success: function (result) {
                if (result == '1') {
                    tour.start();
                }
            }
        });

    });

    jQuery(document).on("click", "#arp_tour_guide_start", function (e) {

        e.preventDefault();
        jQuery('.arp_tables_content_container').scrollTop(0);
        if (jQuery(this).hasClass("disabled")) {
            return;
        }
        tour.restart();
    });

    var $arp_tour_guide_value = jQuery("#arp_tour_guide_value").val();

    if ($arp_tour_guide_value == 'yes') {
        setTimeout(function () {
            jQuery('#arp_tour_guide_model').bPopup();
        }, 1000);
    }

});



function EditorTourGuide(goto) {


    var editortour = new Tour({
        storage: false
    });

    editortour.addSteps([
        {
            element: "#arp_allcolumnsdiv",
            title: "Real Time Editor",
            content: "Below you can see that your selected template is loaded in editor. Here you can modify it as per your need.",
            placement: "top",
            backdrop: true,
            orphan: true,
            onShown: function (tour) {
                jQuery("#arp_allcolumnsdiv").css('box-shadow', '0 0 0 4px rgba(79, 213, 214,1)');
                jQuery("#arp_allcolumnsdiv").css('float', 'left');
                jQuery("#arp_allcolumnsdiv").css('padding-top', '10px');
                jQuery("#arp_allcolumnsdiv").css('background', '#ffffff');
                jQuery(".arp_tour").css('margin-top', '15px');


            },
            onHide: function (editortour) {
                jQuery("#arp_allcolumnsdiv").css('box-shadow', '');
                jQuery("#arp_allcolumnsdiv").css('float', '');
                jQuery("#arp_allcolumnsdiv").css('padding', '');
                jQuery("#arp_allcolumnsdiv").css('background', '');
                jQuery(".arp_tour").css('margin-top', '');

            },
            template: "<div class='popover tour arp_tour'><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button id='arp_next_two' class='arp_tour_next' style='margin:0 15px 15px;' data-role='next'>Next</button><button class='arp_tour_end_tour' style='margin-right:15px;' data-role='end'>End tour</button></div></nav></div>",
        },
        {
            element: ".general_color_opts",
            title: "Choose color",
            content: "Select color of your template by clicking the button. you will see color change is applied right away :)",
            backdrop: true,
            orphan: true,
            placement: "left",
            onShown: function (editortour) {
                jQuery("#arp_allcolumnsdiv").css('z-index', '99999');
                jQuery("#arp_allcolumnsdiv").css('position', 'relative');
                jQuery(".general_color_opts").css('box-shadow', '0 0 0 4px rgba(79, 213, 214,1)');
                jQuery("#arp_allcolumnsdiv").css('box-shadow', '0 0 0 4px rgba(79, 213, 214,1)');
                jQuery("#arp_allcolumnsdiv").css('float', 'left');
                jQuery("#arp_allcolumnsdiv").css('padding-top', '10px');
                jQuery("#arp_allcolumnsdiv").css('background', '#ffffff');


            },
            onHide: function (editortour) {
                jQuery("#arp_allcolumnsdiv").css('z-index', '');
                jQuery("#arp_allcolumnsdiv").css('position', '');
                jQuery(".general_color_opts").css('box-shadow', '');
                jQuery("#arp_allcolumnsdiv").css('box-shadow', '');
                jQuery("#arp_allcolumnsdiv").css('float', '');
                jQuery("#arp_allcolumnsdiv").css('padding', '');
                jQuery("#arp_allcolumnsdiv").css('background', '');

            },
            template: "<div class='popover tour arp_tour' style='margin:75px 0 0 -25px'><div class='arrow arrow_color'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_prev' data-role='prev'>Prev</button> <button id='arp_next_thiree' class='arp_tour_next' data-role='next'>Next</button><button class='arp_tour_end_tour' data-role='end'>End tour</button></div></div>",
        },
        {
            element: "#main_column_0",
            title: "Column level changes",
            content: "First click column and on the right side you will see option bar. After selecting column, double click header area to see options for header part.",
            backdrop: true,
            orphan: true,
            placement: "right",
            onShown: function (editortour) {
                jQuery("#arp_allcolumnsdiv").addClass("no_arp_tour_hover");
                jQuery("#main_column_0").css('box-shadow', '0 0 0 4px rgba(79, 213, 214,1)');

            },
            onHide: function (editortour) {
                jQuery("#arp_allcolumnsdiv").removeClass("no_arp_tour_hover");
                jQuery("#main_column_0").css('box-shadow', '');
            },
            template: "<div style='margin:0 0 0 20px;'; class='popover tour arp_tour'><div class='arrow arrow_header'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_prev' data-role='prev'>Prev</button><button id='arp_next_four' class='arp_tour_next' data-role='next'>Next</button><button class='arp_tour_end_tour' data-role='end'>End tour</button></div></div>",
        },
        {
            element: "#main_column_0",
            title: "Pricing area change",
            content: "Set pricing and its interval from this area.",
            backdrop: true,
            orphan: true,
            placement: "right",
            onShown: function (editortour) {
                jQuery("#arp_allcolumnsdiv").addClass("no_arp_tour_hover");
                jQuery("#main_column_0").addClass("ArpPricingTableColumnWrapper_inner_selected selected");
                jQuery("#main_column_0").css('z-index', '9999');
                jQuery("#main_column_0").find(".arppricetablecolumnprice").trigger("dblclick");

            },
            onHide: function (editortour) {
                jQuery("#arp_allcolumnsdiv").removeClass("no_arp_tour_hover");
                jQuery("#main_column_0").removeClass("ArpPricingTableColumnWrapper_inner_selected selected");
                jQuery("#main_column_0").css('z-index', '');
            },
            template: "<div style='margin:0 0 0 20px;'; class='popover tour arp_tour'><div class='arrow arrow_price'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_prev' data-role='prev'>Prev</button><button id='arp_next_four' class='arp_tour_next' data-role='next'>Next</button><button class='arp_tour_end_tour' data-role='end'>End tour</button></div></div>",
        },
        {
            element: "#preview_btn",
            title: "Preview button",
            content: "click 'Next' or 'Preview' button to view your applied changes in separate responsive tab.",
            backdrop: true,
            orphan: true,
            placement: "bottom",
            onNext: function (editortour) {
                jQuery("#preview_btn").css('box-shadow', '');
                jQuery("#preview_btn").addClass('DisplayTourGuide');
                jQuery('#preview_btn').trigger('click');
                jQuery("#arp_allcolumnsdiv").addClass("no_arp_tour_hover");

                editortour.end();
            },
            onShown: function (editortour) {
                jQuery("#preview_btn").addClass('DisplayTourGuide');
            },
            template: "<div style='margin:12px 0 0 -10px;' class='popover tour arp_tour'><div class='arrow'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_prev' data-role='prev'>Prev</button><button id='arp_next_preview' class='arp_tour_next' data-role='next'>Next</button><button class='arp_tour_end_tour' data-role='end'>End tour</button></div></div>",
        }
    ]);

    setTimeout(function () {
        editortour.init();
        editortour.start();
        if (goto > 0) {
            editortour.goTo(goto);
        }
    }, 1000);

}





function previewTour(goto) {
    var previewtours = new Tour({
        storage: false
    });

    previewtours.addSteps([
        {
            element: ".mobile_icon",
            title: "Change views",
            content: "Hit Next or Mobile button to view pricing table preview in mobile view.",
            backdrop: true,
            orphan: true,
            placement: "bottom",
            onShown: function (previewtours) {
                jQuery("#preview_btn").removeClass('DisplayTourGuide');
            },
            onNext: function (previewtours) {
                jQuery('#mobile_icon').trigger('click');
            },
            onPrev: function (previewtours) {
                EditorTourGuide(4);
                jQuery('#arp_pricing_table_preview .b-close').trigger('click');
                previewtours.end();

            },
            template: "<div style='margin-top:23px;' class='popover tour arp_tour_preview'><div class='arrow'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_prev' data-role='prev'>Prev</button><button id='arp_next_mobile' class='arp_tour_next' data-role='next'>Next</button><button class='arp_tour_end_tour' data-role='end'>End tour</button></div></div>",
        },
        {
            element: ".mobile_icon",
            title: "Mobile View",
            content: "Click 'Next' or close button to get back to editor area.",
            backdrop: true,
            orphan: true,
            placement: "bottom",
            onShown: function (previewtours) {
                jQuery("#preview_btn").removeClass('DisplayTourGuide');

            },
            onNext: function (previewtours) {

                AnimationTours();
                jQuery('#arp_pricing_table_preview .b-close').trigger('click');
                previewtours.end();
            },
            onPrev: function (previewtours) {
                jQuery('#computer_icon').trigger('click');
            },
            template: "<div style='margin-top:23px;' class='popover tour arp_tour_preview'><div class='arrow'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_prev' data-role='prev'>Prev</button><button id='arp_next_mobile' class='arp_tour_next' data-role='next'>Next</button><button class='arp_tour_end_tour' data-role='end'>End tour</button></div></div>",
        }
    ]);

    setTimeout(function () {
        previewtours.init();
        previewtours.start();
        if (goto > 0) {
            previewtours.goTo(goto);
        }

    }, 1000);

}


function AnimationTours() {
    var animationtour = new Tour({
        storage: false
    });

    animationtour.addSteps([
        {
            element: ".arprice_options_menu_belt",
            title: "General settings",
            content: "All the template level options like column options, animation effects, tooltip settings etc can be changed in general setting area.",
            backdrop: true,
            orphan: true,
            placement: "bottom",
            onShown: function (animationtour) {
                jQuery("#preview_btn").removeClass('DisplayTourGuide');
                jQuery(".arprice_options_menu_belt").css('box-shadow', '0 0 0 4px rgba(79, 213, 214,1)');
                jQuery(".arprice_options_menu_belt").css('margin', '0 4px 0 4px');



                var width1 = jQuery('#column_options').width();
                var width2 = jQuery('#column_effects').width();
                var width3 = jQuery('#tootip_options').width();
                var width4 = jQuery('#custom_css_options').width();
                var width5 = jQuery('#toggle_content_options').width();
		var width6 = jQuery('#all_font_options').width();

                var general_width = parseInt(width1) + parseInt(width2) + parseInt(width3) + parseInt(width4) + parseInt(width5) + parseInt(width6);

                jQuery('.arprice_options_menu_belt').css('width', (general_width + 80));

                if (jQuery.browser.safari) {
                    jQuery(".arp_tour_preview").css('margin-left', '-75%');
                }

                jQuery(".arprice_options_menu_belt").css('background', '#ffffff');
                jQuery(".arprice_top_belt_menu_right").hide();


            },
            onHide: function (animationtour) {
                jQuery(".arprice_options_menu_belt").css('box-shadow', '');
                jQuery(".arprice_options_menu_belt").css('margin', '');
                jQuery(".arprice_options_menu_belt").css('width', '');
                jQuery(".arprice_options_menu_belt").css('background', '');

                jQuery(".arp_tour_preview").css('margin-left', '-25%');

                jQuery(".arprice_top_belt_menu_right").show();

            },
            onNext: function (animationtour) {
                jQuery(".arp_shortcode").show();
                jQuery('#save_btn').trigger('click');

            },
            onPrev: function (animationtour) {
                jQuery(".arprice_options_menu_belt").css('box-shadow', '');
                jQuery(".arprice_options_menu_belt").css('margin', '');
                jQuery(".arprice_options_menu_belt").css('width', '');
                jQuery(".arprice_options_menu_belt").css('background', '');
                jQuery("#preview_btn").addClass('DisplayTourGuide');
                jQuery('#preview_btn').trigger('click');
                animationtour.end();

            },
            template: "<div style='margin:21px 0 0 -25%;' class='popover tour arp_tour_preview'><div class='arrow'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_prev' data-role='prev'>Prev</button><button id='arp_next_effects' class='arp_tour_next' data-role='next'>Next</button><button class='arp_tour_end_tour' data-role='end'>End tour</button></div></div>",
        },
        {
            element: ".arp_shortcode",
            title: "Finish",
            content: 'Once you click save button all your changes will be saved as clone of existing template. you can right away copy short code and put it on page. </br>Thank you',
            backdrop: true,
            orphan: true,
            placement: "bottom",
            onShown: function (animationtour) {
                jQuery(".arp_shortcode").show();
                jQuery(".arp_shortcode").css('box-shadow', '0 0 0 4px rgba(79, 213, 214,1)');
                jQuery(".arp_shortcode").css('background', '#ffffff');

            },
            onHide: function (animationtour) {
                jQuery(".arprice_options_menu_belt").css('box-shadow', '');
            },
            onNext: function (animationtour) {
                animationtour.end();
                window.location.href = "admin.php?page=arpricelite";
            },
            template: "<div style='margin:18px 0 0 0' class='popover tour arp_tour_preview'><div class='arrow'></div><h3 class='popover-title'></h3><div class='popover-content'></div><div class='popover-navigation'><button class='arp_tour_end_tour' data-role='next'>End tour</button></div></div>",
        },
    ]);

    setTimeout(function () {
        animationtour.init();
        animationtour.start();
    }, 1000);

}